/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworkSecurityMirroringEndpointGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * User-provided description of the endpoint group.
    * Used as additional context for the endpoint group.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#description NetworkSecurityMirroringEndpointGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#id NetworkSecurityMirroringEndpointGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Labels are key/value pairs that help to organize and filter resources.
    *
    * **Note**: This field is non-authoritative, and will only manage the labels present in your configuration.
    * Please refer to the field 'effective_labels' for all of the labels present on the resource.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#labels NetworkSecurityMirroringEndpointGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * The cloud location of the endpoint group, currently restricted to 'global'.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#location NetworkSecurityMirroringEndpointGroup#location}
    */
    readonly location: string;
    /**
    * The deployment group that this DIRECT endpoint group is connected to, for example:
    * 'projects/123456789/locations/global/mirroringDeploymentGroups/my-dg'.
    * See https://google.aip.dev/124.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#mirroring_deployment_group NetworkSecurityMirroringEndpointGroup#mirroring_deployment_group}
    */
    readonly mirroringDeploymentGroup: string;
    /**
    * The ID to use for the endpoint group, which will become the final component
    * of the endpoint group's resource name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#mirroring_endpoint_group_id NetworkSecurityMirroringEndpointGroup#mirroring_endpoint_group_id}
    */
    readonly mirroringEndpointGroupId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#project NetworkSecurityMirroringEndpointGroup#project}
    */
    readonly project?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#timeouts NetworkSecurityMirroringEndpointGroup#timeouts}
    */
    readonly timeouts?: NetworkSecurityMirroringEndpointGroupTimeouts;
}
export interface NetworkSecurityMirroringEndpointGroupAssociations {
}
export declare function networkSecurityMirroringEndpointGroupAssociationsToTerraform(struct?: NetworkSecurityMirroringEndpointGroupAssociations): any;
export declare function networkSecurityMirroringEndpointGroupAssociationsToHclTerraform(struct?: NetworkSecurityMirroringEndpointGroupAssociations): any;
export declare class NetworkSecurityMirroringEndpointGroupAssociationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NetworkSecurityMirroringEndpointGroupAssociations | undefined;
    set internalValue(value: NetworkSecurityMirroringEndpointGroupAssociations | undefined);
    get name(): string;
    get network(): string;
    get state(): string;
}
export declare class NetworkSecurityMirroringEndpointGroupAssociationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NetworkSecurityMirroringEndpointGroupAssociationsOutputReference;
}
export interface NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocations {
}
export declare function networkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocationsToTerraform(struct?: NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocations): any;
export declare function networkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocationsToHclTerraform(struct?: NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocations): any;
export declare class NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocations | undefined;
    set internalValue(value: NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocations | undefined);
    get location(): string;
    get state(): string;
}
export declare class NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocationsOutputReference;
}
export interface NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroups {
}
export declare function networkSecurityMirroringEndpointGroupConnectedDeploymentGroupsToTerraform(struct?: NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroups): any;
export declare function networkSecurityMirroringEndpointGroupConnectedDeploymentGroupsToHclTerraform(struct?: NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroups): any;
export declare class NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroups | undefined;
    set internalValue(value: NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroups | undefined);
    private _locations;
    get locations(): NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsLocationsList;
    get name(): string;
}
export declare class NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsOutputReference;
}
export interface NetworkSecurityMirroringEndpointGroupTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#create NetworkSecurityMirroringEndpointGroup#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#delete NetworkSecurityMirroringEndpointGroup#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#update NetworkSecurityMirroringEndpointGroup#update}
    */
    readonly update?: string;
}
export declare function networkSecurityMirroringEndpointGroupTimeoutsToTerraform(struct?: NetworkSecurityMirroringEndpointGroupTimeouts | cdktf.IResolvable): any;
export declare function networkSecurityMirroringEndpointGroupTimeoutsToHclTerraform(struct?: NetworkSecurityMirroringEndpointGroupTimeouts | cdktf.IResolvable): any;
export declare class NetworkSecurityMirroringEndpointGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): NetworkSecurityMirroringEndpointGroupTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: NetworkSecurityMirroringEndpointGroupTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group google_network_security_mirroring_endpoint_group}
*/
export declare class NetworkSecurityMirroringEndpointGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_network_security_mirroring_endpoint_group";
    /**
    * Generates CDKTF code for importing a NetworkSecurityMirroringEndpointGroup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworkSecurityMirroringEndpointGroup to import
    * @param importFromId The id of the existing NetworkSecurityMirroringEndpointGroup that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworkSecurityMirroringEndpointGroup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google/6.40.0/docs/resources/network_security_mirroring_endpoint_group google_network_security_mirroring_endpoint_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworkSecurityMirroringEndpointGroupConfig
    */
    constructor(scope: Construct, id: string, config: NetworkSecurityMirroringEndpointGroupConfig);
    private _associations;
    get associations(): NetworkSecurityMirroringEndpointGroupAssociationsList;
    private _connectedDeploymentGroups;
    get connectedDeploymentGroups(): NetworkSecurityMirroringEndpointGroupConnectedDeploymentGroupsList;
    get createTime(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _effectiveLabels;
    get effectiveLabels(): cdktf.StringMap;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    get locationInput(): string | undefined;
    private _mirroringDeploymentGroup?;
    get mirroringDeploymentGroup(): string;
    set mirroringDeploymentGroup(value: string);
    get mirroringDeploymentGroupInput(): string | undefined;
    private _mirroringEndpointGroupId?;
    get mirroringEndpointGroupId(): string;
    set mirroringEndpointGroupId(value: string);
    get mirroringEndpointGroupIdInput(): string | undefined;
    get name(): string;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    get reconciling(): cdktf.IResolvable;
    get state(): string;
    private _terraformLabels;
    get terraformLabels(): cdktf.StringMap;
    get updateTime(): string;
    private _timeouts;
    get timeouts(): NetworkSecurityMirroringEndpointGroupTimeoutsOutputReference;
    putTimeouts(value: NetworkSecurityMirroringEndpointGroupTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | NetworkSecurityMirroringEndpointGroupTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
